"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const handler_1 = require("./handler");
const provider_1 = require("./provider");
const info_1 = require("./info");
exports.plugin = {
    name: info_1.name,
    version: info_1.version,
    register(server, options) {
        return __awaiter(this, void 0, void 0, function* () {
            if (!options.providers) {
                throw new Error('Providers array not supplied');
            }
            options.baseUrl = options.baseUrl || server.info.uri;
            options.handler = options.handler || new handler_1.OAuthHandler();
            options.providers.forEach(provider => {
                provider_1.registerProvider(server, options, provider);
            });
        });
    },
};
