import { Provider, Scopes, AccessTokens } from '../provider';
import { Profile } from '../profile';
export declare class DiscordProfile implements Profile {
    id: string;
    username: string;
    discriminator: string;
    avatar: string;
    bot: boolean;
    mfa_enabled: boolean;
    verified: boolean;
    email: string;
    constructor(profile: any);
    getUniqueId(): string;
}
export declare class DiscordProvider extends Provider {
    clientId: string;
    clientSecret: string;
    scopes: Scopes;
    name: string;
    tokenUrl: string;
    authUrl: string;
    profileUrl: string;
    constructor(clientId: string, clientSecret: string, scopes?: Scopes);
    requestToken(code: string, redirect_uri: string): Promise<any>;
    getProfile(tokens: AccessTokens): Promise<DiscordProfile>;
}
