"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const node_fetch_1 = require("node-fetch");
const provider_1 = require("../provider");
class GoogleProfile {
    constructor(profile) {
        Object.assign(this, profile);
    }
    getUniqueId() {
        return this.id;
    }
}
exports.GoogleProfile = GoogleProfile;
class GoogleProvider extends provider_1.Provider {
    constructor(clientId, clientSecret, scopes) {
        super();
        this.clientId = clientId;
        this.clientSecret = clientSecret;
        this.scopes = scopes;
        this.name = 'google';
        this.tokenUrl = 'https://www.googleapis.com/oauth2/v4/token';
        this.authUrl = 'https://accounts.google.com/o/oauth2/v2/auth';
        this.profileUrl = 'https://www.googleapis.com/oauth2/v1/userinfo';
        this.encoding = 'application/x-www-form-urlencoded';
        this.query = {
            // Offline allows refreshing when the user isn't present
            access_type: 'offline',
        };
    }
    getProfile(tokens) {
        return node_fetch_1.default(this.profileUrl, {
            headers: {
                Authorization: `Bearer ${tokens.access_token}`,
            },
        })
            .then(res => res.json())
            .then(profile => new GoogleProfile(profile));
    }
}
exports.GoogleProvider = GoogleProvider;
