import { Provider, Scopes, AccessTokens } from "../provider";
import { Profile } from "../profile";
export declare class MicrosoftProfile implements Profile {
    id: string;
    avatar: string;
    displayName: string;
    givenName: string;
    jobTitle: boolean;
    mail: string;
    surname: string;
    userPrincipalName: string;
    constructor(profile: any);
    getUniqueId(): string;
}
export declare class MicrosoftProvider extends Provider {
    clientId: string;
    clientSecret: string;
    scopes: Scopes;
    name: string;
    private tenant;
    tokenUrl: string;
    authUrl: string;
    profileUrl: string;
    constructor(clientId: string, clientSecret: string, scopes?: Scopes);
    requestToken(code: string, redirect_uri: string): Promise<any>;
    getProfile(tokens: AccessTokens): Promise<MicrosoftProfile>;
}
