import { Provider, Scopes, AccessTokens } from '../provider';
import { Profile } from '../profile';
export declare class MixerProfile implements Profile {
    id: number;
    username: string;
    email: string;
    verified: boolean;
    experience: number;
    sparks: number;
    level: number;
    bio: string;
    primaryTeam: number;
    frontendVersion?: string;
    createdAt: string;
    updatedAt: string;
    deletedAt: string;
    constructor(profile: any);
    getUniqueId(): number;
}
export declare class MixerProvider extends Provider {
    clientId: string;
    clientSecret: string;
    scopes: Scopes;
    name: string;
    tokenUrl: string;
    authUrl: string;
    profileUrl: string;
    constructor(clientId: string, clientSecret: string, scopes: Scopes);
    getProfile(tokens: AccessTokens): Promise<MixerProfile>;
}
