"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const node_fetch_1 = require("node-fetch");
const provider_1 = require("../provider");
class MixerProfile {
    constructor(profile) {
        Object.assign(this, profile);
    }
    getUniqueId() {
        return this.id;
    }
}
exports.MixerProfile = MixerProfile;
class MixerProvider extends provider_1.Provider {
    constructor(clientId, clientSecret, scopes) {
        super();
        this.clientId = clientId;
        this.clientSecret = clientSecret;
        this.scopes = scopes;
        this.name = 'mixer';
        this.tokenUrl = 'https://mixer.com/api/v1/oauth/token';
        this.authUrl = 'https://mixer.com/oauth/authorize';
        this.profileUrl = 'https://mixer.com/api/v1/users/current';
    }
    getProfile(tokens) {
        return node_fetch_1.default(this.profileUrl, {
            headers: {
                'Client-ID': this.clientId,
                Authorization: `Bearer ${tokens.access_token}`,
            },
        })
            .then(res => res.json())
            .then(profile => new MixerProfile(profile));
    }
}
exports.MixerProvider = MixerProvider;
