"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Wreck = require("wreck");
const qs = require("querystring");
const provider_1 = require("../provider");
class PatreonProvider extends provider_1.Provider {
    constructor(clientId, clientSecret, scopes = []) {
        super();
        this.clientId = clientId;
        this.clientSecret = clientSecret;
        this.scopes = scopes;
        this.name = 'patreon';
        this.tokenUrl = 'https://api.patreon.com/oauth2/token';
        this.authUrl = 'https://www.patreon.com/oauth2/authorize';
    }
    requestToken(code, redirect_uri) {
        return new Promise((resolve, reject) => {
            const query = {
                code,
                redirect_uri,
                client_id: this.clientId,
                client_secret: this.clientSecret,
                grant_type: 'authorization_code',
            };
            Wreck.post(`${this.tokenUrl}?${qs.stringify(query)}`, {
                json: true,
            }, (err, message, res) => {
                if (err) {
                    reject(err);
                    return;
                }
                if (res.error) {
                    const error = new Error(res.error_description);
                    error.name = err.error;
                    reject(error);
                    return;
                }
                resolve(res);
            });
        });
    }
}
exports.PatreonProvider = PatreonProvider;
