import { Provider, Scopes, AccessTokens } from '../provider';
import { Profile } from '../profile';
export declare class PicartoProfile implements Profile {
    channel_details: {
        user_id: number;
        name: string;
        online: boolean;
        viewers: number;
        viewers_total: number;
        followers: number;
        adult: boolean;
        category: string;
        account_type: string;
        commissions: boolean;
        title: string;
        description_panels: any[];
        private: boolean;
        gaming: boolean;
        guest_chat: boolean;
        last_live: string;
        tags: string[];
        multistream: any[];
    };
    email: string;
    creation_date: string;
    private_key: string;
    following: {
        user_id: number;
        name: string;
    }[];
    subscriptions: {
        user_id: number;
        name: string;
    }[];
    constructor(profile: any);
    getUniqueId(): number;
}
export declare class PicartoProvider extends Provider {
    clientId: string;
    clientSecret: string;
    scopes: Scopes;
    name: string;
    tokenUrl: string;
    authUrl: string;
    profileUrl: string;
    constructor(clientId: string, clientSecret: string, scopes: Scopes);
    requestToken(code: string, redirect_uri: string): Promise<{}>;
    getProfile(tokens: AccessTokens): Promise<PicartoProfile>;
}
