"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const provider_1 = require("../provider");
const node_fetch_1 = require("node-fetch");
class TwitchProfile {
    constructor(profile) {
        Object.assign(this, profile);
    }
    getUniqueId() {
        return String(this._id);
    }
}
exports.TwitchProfile = TwitchProfile;
class TwitchProvider extends provider_1.Provider {
    constructor(clientId, clientSecret, scopes) {
        super();
        this.clientId = clientId;
        this.clientSecret = clientSecret;
        this.scopes = scopes;
        this.name = 'twitch';
        this.tokenUrl = 'https://api.twitch.tv/kraken/oauth2/token';
        this.authUrl = 'https://api.twitch.tv/kraken/oauth2/authorize';
        this.profileUrl = 'https://api.twitch.tv/kraken/user';
    }
    getProfile(tokens) {
        return node_fetch_1.default(this.profileUrl, {
            headers: {
                Accept: 'application/vnd.twitchtv.v5+json',
                'Client-ID': this.clientId,
                Authorization: `OAuth ${tokens.access_token}`,
            },
        })
            .then(res => res.json())
            .then(profile => new TwitchProfile(profile));
    }
}
exports.TwitchProvider = TwitchProvider;
